/// <reference types="react" />
import * as react from 'react';

interface BaseConfig {
    appName: string;
    env: string;
    version: string;
    basename: string;
}
interface ConfigContextValue {
    config: BaseConfig;
}

declare const ConfigProvider: react.Provider<ConfigContextValue>;
declare const useConfig: <T extends BaseConfig>() => T;
declare const confLoader: () => <T extends BaseConfig>() => T;

declare const parse: (s: string) => Record<string, string>;
declare const withPrefix: (o: Record<string, string>) => Record<string, string>;
declare const stringify: (o: Record<string, string>) => string;

export { BaseConfig, ConfigContextValue, ConfigProvider, confLoader, parse, stringify, useConfig, withPrefix };
