'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _concatInstanceProperty = require('@babel/runtime-corejs3/core-js/instance/concat');
var config = require('@react2rx/bootstrap/config');
var core = require('@react2rx/core');
var router = require('@react2rx/router');
var react = require('react');
var client = require('react-dom/client');
var persister = require('@react2rx/bootstrap/persister');
var jsxRuntime = require('react/jsx-runtime');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () { return e[k]; }
        });
      }
    });
  }
  n["default"] = e;
  return Object.freeze(n);
}

var _concatInstanceProperty__default = /*#__PURE__*/_interopDefaultLegacy(_concatInstanceProperty);

var {
  typeWith
} = core.actor;
var applyLogger = so$ => {
  if (process.env.NODE_ENV === "production") {
    return;
  }
  // @ts-ignore
  void Promise.resolve().then(function () { return /*#__PURE__*/_interopNamespace(require('redux-logger')); }).then(_ref => {
    var {
      createLogger
    } = _ref;
    var logger = /*#__PURE__*/createLogger({
      duration: true,
      collapsed: true,
      errorTransformer(e) {
        throw e;
      },
      titleFormatter(actor, time, took) {
        var _context, _context2;
        return _concatInstanceProperty__default["default"](_context = /*#__PURE__*/_concatInstanceProperty__default["default"](_context2 = /*#__PURE__*/"action @ ".concat(time, " ")).call(_context2, /*#__PURE__*/typeWith(actor), " (in ")).call(_context, /*#__PURE__*/took.toFixed(2), " ms)");
      },
      colors: {
        title(actor) {
          switch (actor.stage) {
            case core.AsyncStage.STARTED:
              return "blue";
            case core.AsyncStage.DONE:
              return "green";
            case core.AsyncStage.FAILED:
              return "red";
            case core.AsyncStage.CANCEL:
              return "orange";
          }
          return "gray";
        }
      }
    });
    so$.applyMiddleware(logger);
  });
};
var createBootstrap = config$1 => e => {
  // eslint-disable-next-line
  console.log(config$1);
  var persister$1 = /*#__PURE__*/persister.persister(config$1.appName || "app");
  return function ($root) {
    var strictMode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    var r = /*#__PURE__*/client.createRoot($root);
    var storeValue = /*#__PURE__*/persister$1.hydrate();
    var store$ = /*#__PURE__*/core.Store.create(storeValue);
    applyLogger(store$);
    var app = /*#__PURE__*/jsxRuntime.jsx(core.StoreProvider, {
      value: store$,
      children: /*#__PURE__*/jsxRuntime.jsxs(config.ConfigProvider, {
        value: {
          config: config$1
        },
        children: [/*#__PURE__*/jsxRuntime.jsx(persister.PersisterConnect, {
          persister: persister$1
        }), /*#__PURE__*/jsxRuntime.jsx(router.React2rxRouter, {
          basename: config$1.basename,
          children: typeof e === "function" ? e() : e
        })]
      })
    });
    if (strictMode) {
      r.render( /*#__PURE__*/jsxRuntime.jsx(react.StrictMode, {
        children: app
      }));
    } else {
      r.render(app);
    }
  };
};

exports.createBootstrap = createBootstrap;
