import _concatInstanceProperty from '@babel/runtime-corejs3/core-js/instance/concat';
import { ConfigProvider } from '@react2rx/bootstrap/config';
import { StoreProvider, Store, AsyncStage, actor } from '@react2rx/core';
import { React2rxRouter } from '@react2rx/router';
import { StrictMode } from 'react';
import { createRoot } from 'react-dom/client';
import { persister, PersisterConnect } from '@react2rx/bootstrap/persister';
import { jsx, jsxs } from 'react/jsx-runtime';

var {
  typeWith
} = actor;
var applyLogger = so$ => {
  if (process.env.NODE_ENV === "production") {
    return;
  }
  // @ts-ignore
  void import('redux-logger').then(_ref => {
    var {
      createLogger
    } = _ref;
    var logger = /*#__PURE__*/createLogger({
      duration: true,
      collapsed: true,
      errorTransformer(e) {
        throw e;
      },
      titleFormatter(actor, time, took) {
        var _context, _context2;
        return _concatInstanceProperty(_context = /*#__PURE__*/_concatInstanceProperty(_context2 = /*#__PURE__*/"action @ ".concat(time, " ")).call(_context2, /*#__PURE__*/typeWith(actor), " (in ")).call(_context, /*#__PURE__*/took.toFixed(2), " ms)");
      },
      colors: {
        title(actor) {
          switch (actor.stage) {
            case AsyncStage.STARTED:
              return "blue";
            case AsyncStage.DONE:
              return "green";
            case AsyncStage.FAILED:
              return "red";
            case AsyncStage.CANCEL:
              return "orange";
          }
          return "gray";
        }
      }
    });
    so$.applyMiddleware(logger);
  });
};
var createBootstrap = config => e => {
  // eslint-disable-next-line
  console.log(config);
  var persister$1 = /*#__PURE__*/persister(config.appName || "app");
  return function ($root) {
    var strictMode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    var r = /*#__PURE__*/createRoot($root);
    var storeValue = /*#__PURE__*/persister$1.hydrate();
    var store$ = /*#__PURE__*/Store.create(storeValue);
    applyLogger(store$);
    var app = /*#__PURE__*/jsx(StoreProvider, {
      value: store$,
      children: /*#__PURE__*/jsxs(ConfigProvider, {
        value: {
          config
        },
        children: [/*#__PURE__*/jsx(PersisterConnect, {
          persister: persister$1
        }), /*#__PURE__*/jsx(React2rxRouter, {
          basename: config.basename,
          children: typeof e === "function" ? e() : e
        })]
      })
    });
    if (strictMode) {
      r.render( /*#__PURE__*/jsx(StrictMode, {
        children: app
      }));
    } else {
      r.render(app);
    }
  };
};

export { createBootstrap };
