'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime-corejs3/helpers/defineProperty');
var _startsWithInstanceProperty = require('@babel/runtime-corejs3/core-js/instance/starts-with');
var _includesInstanceProperty = require('@babel/runtime-corejs3/core-js/instance/includes');
var _globalThis = require('@babel/runtime-corejs3/core-js/global-this');
var _Object$keys = require('@babel/runtime-corejs3/core-js/object/keys');
var _Object$getOwnPropertySymbols = require('@babel/runtime-corejs3/core-js/object/get-own-property-symbols');
var _filterInstanceProperty = require('@babel/runtime-corejs3/core-js/instance/filter');
var _Object$getOwnPropertyDescriptor = require('@babel/runtime-corejs3/core-js/object/get-own-property-descriptor');
var _forEachInstanceProperty = require('@babel/runtime-corejs3/core-js/instance/for-each');
var _Object$getOwnPropertyDescriptors = require('@babel/runtime-corejs3/core-js/object/get-own-property-descriptors');
var _Object$defineProperties = require('@babel/runtime-corejs3/core-js/object/define-properties');
var _Object$defineProperty = require('@babel/runtime-corejs3/core-js/object/define-property');
var localMemory = require('@react2rx/bootstrap/localMemory');
var rxjs = require('rxjs');
var operators = require('rxjs/operators');
var lodash = require('@rontrol/lodash');
var core = require('@react2rx/core');
var react = require('react');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var _startsWithInstanceProperty__default = /*#__PURE__*/_interopDefaultLegacy(_startsWithInstanceProperty);
var _includesInstanceProperty__default = /*#__PURE__*/_interopDefaultLegacy(_includesInstanceProperty);
var _globalThis__default = /*#__PURE__*/_interopDefaultLegacy(_globalThis);
var _Object$keys__default = /*#__PURE__*/_interopDefaultLegacy(_Object$keys);
var _Object$getOwnPropertySymbols__default = /*#__PURE__*/_interopDefaultLegacy(_Object$getOwnPropertySymbols);
var _filterInstanceProperty__default = /*#__PURE__*/_interopDefaultLegacy(_filterInstanceProperty);
var _Object$getOwnPropertyDescriptor__default = /*#__PURE__*/_interopDefaultLegacy(_Object$getOwnPropertyDescriptor);
var _forEachInstanceProperty__default = /*#__PURE__*/_interopDefaultLegacy(_forEachInstanceProperty);
var _Object$getOwnPropertyDescriptors__default = /*#__PURE__*/_interopDefaultLegacy(_Object$getOwnPropertyDescriptors);
var _Object$defineProperties__default = /*#__PURE__*/_interopDefaultLegacy(_Object$defineProperties);
var _Object$defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_Object$defineProperty);

function ownKeys(object, enumerableOnly) { var keys = /*#__PURE__*/_Object$keys__default["default"](object); if (_Object$getOwnPropertySymbols__default["default"]) { var symbols = /*#__PURE__*/_Object$getOwnPropertySymbols__default["default"](object); enumerableOnly && (symbols = /*#__PURE__*/_filterInstanceProperty__default["default"](symbols).call(symbols, function (sym) { return _Object$getOwnPropertyDescriptor__default["default"](object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var _context2, _context3; var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? _forEachInstanceProperty__default["default"](_context2 = /*#__PURE__*/ownKeys( /*#__PURE__*/Object(source), !0)).call(_context2, function (key) { _defineProperty__default["default"](target, key, source[key]); }) : _Object$getOwnPropertyDescriptors__default["default"] ? _Object$defineProperties__default["default"](target, /*#__PURE__*/_Object$getOwnPropertyDescriptors__default["default"](source)) : _forEachInstanceProperty__default["default"](_context3 = /*#__PURE__*/ownKeys( /*#__PURE__*/Object(source))).call(_context3, function (key) { _Object$defineProperty__default["default"](target, key, /*#__PURE__*/_Object$getOwnPropertyDescriptor__default["default"](source, key)); }); } return target; }

// 根据 store state key 的前缀 $ 决定是否要缓存 (双 $$ 表示要多 tab 同步)。
// 另外如果 store state 的值是 object 且有 expireAt(RFC3339) 字段，将判断是否过期。过期则不读。

var persistp = function persistp() {
  var key = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
  return [/*#__PURE__*/_startsWithInstanceProperty__default["default"](key).call(key, "$"), key[1] === "$"];
};
var persister = name => {
  var memory = /*#__PURE__*/localMemory.localMemory({
    name: name || "app"
  });
  var connect = store$ => {
    var prevState = {};
    var sub = /*#__PURE__*/rxjs.merge( /*#__PURE__*/store$.pipe( /*#__PURE__*/operators.tap(function () {
      var nextState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var allPersists = /*#__PURE__*/lodash.uniq( /*#__PURE__*/lodash.filter([...lodash.keys(prevState), ...lodash.keys(nextState)], key => persistp(key)[0]));
      if (lodash.some(allPersists, it => _includesInstanceProperty__default["default"](it).call(it, "access"))) {
        memory.clear();
        return;
      }
      var {
        toR,
        toS
      } = /*#__PURE__*/lodash.reduce(allPersists, (prev, cur) => {
        if (!!prevState[cur] && typeof nextState[cur] === "undefined") {
          prev.toR.push(cur);
        } else {
          prev.toS.$persist.push(cur);
          if (nextState[cur] !== prevState[cur]) {
            prev.toS[cur] = nextState[cur];
          }
        }
        return prev;
      }, {
        toR: [],
        toS: {
          $persist: []
        }
      });
      prevState = nextState;
      void memory.writeByRecord(toS);
      memory.remove(...toR);
    })), /*#__PURE__*/rxjs.fromEvent(_globalThis__default["default"], "storage").pipe( /*#__PURE__*/operators.tap(e => {
      var _context;
      if (!e.isTrusted || !e.key || !e.newValue) {
        return;
      }
      var prefix = memory.keyPrefix;
      if (!_startsWithInstanceProperty__default["default"](_context = e.key).call(_context, prefix)) {
        return;
      }
      var finalKey = /*#__PURE__*/e.key.replace(prefix, "");
      if (finalKey[1] !== "$") {
        return;
      }
      try {
        var value = /*#__PURE__*/JSON.parse(e.newValue);
        store$.next( /*#__PURE__*/_objectSpread( /*#__PURE__*/_objectSpread({}, store$.value), {}, {
          [finalKey]: value
        }));
        console.warn(finalKey, "updated from storage");
      } catch (e) {
        // -
      }
    }))).subscribe();
    return () => {
      prevState = {};
      sub.unsubscribe();
    };
  };
  var hydrate = () => {
    var persistKeys = /*#__PURE__*/memory.read("$persist");
    var parsed = /*#__PURE__*/lodash.reduce(persistKeys, (prev, cur) => {
      var value = /*#__PURE__*/memory.readByExpired(cur);
      if (typeof value !== "undefined" && value !== null) {
        prev[cur] = value;
      }
      return prev;
    }, {});
    if (process.env.NODE_ENV !== "production") {
      // eslint-disable-next-line
      console.log("hydrated", parsed);
    }
    return parsed;
  };
  return {
    connect,
    hydrate
  };
};

var PersisterConnect = _ref => {
  var {
    persister
  } = _ref;
  var store$ = /*#__PURE__*/core.useStore();
  react.useEffect(() => {
    var cleanup = /*#__PURE__*/persister.connect(store$);
    return () => cleanup();
  }, []);
  return null;
};

exports.PersisterConnect = PersisterConnect;
exports.persister = persister;
