import _defineProperty from '@babel/runtime-corejs3/helpers/defineProperty';
import _startsWithInstanceProperty from '@babel/runtime-corejs3/core-js/instance/starts-with';
import _includesInstanceProperty from '@babel/runtime-corejs3/core-js/instance/includes';
import _globalThis from '@babel/runtime-corejs3/core-js/global-this';
import _Object$keys from '@babel/runtime-corejs3/core-js/object/keys';
import _Object$getOwnPropertySymbols from '@babel/runtime-corejs3/core-js/object/get-own-property-symbols';
import _filterInstanceProperty from '@babel/runtime-corejs3/core-js/instance/filter';
import _Object$getOwnPropertyDescriptor from '@babel/runtime-corejs3/core-js/object/get-own-property-descriptor';
import _forEachInstanceProperty from '@babel/runtime-corejs3/core-js/instance/for-each';
import _Object$getOwnPropertyDescriptors from '@babel/runtime-corejs3/core-js/object/get-own-property-descriptors';
import _Object$defineProperties from '@babel/runtime-corejs3/core-js/object/define-properties';
import _Object$defineProperty from '@babel/runtime-corejs3/core-js/object/define-property';
import { localMemory } from '@react2rx/bootstrap/localMemory';
import { merge, fromEvent } from 'rxjs';
import { tap } from 'rxjs/operators';
import { uniq, filter, keys, some, reduce } from '@rontrol/lodash';
import { useStore } from '@react2rx/core';
import { useEffect } from 'react';

function ownKeys(object, enumerableOnly) { var keys = /*#__PURE__*/_Object$keys(object); if (_Object$getOwnPropertySymbols) { var symbols = /*#__PURE__*/_Object$getOwnPropertySymbols(object); enumerableOnly && (symbols = /*#__PURE__*/_filterInstanceProperty(symbols).call(symbols, function (sym) { return _Object$getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var _context2, _context3; var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? _forEachInstanceProperty(_context2 = /*#__PURE__*/ownKeys( /*#__PURE__*/Object(source), !0)).call(_context2, function (key) { _defineProperty(target, key, source[key]); }) : _Object$getOwnPropertyDescriptors ? _Object$defineProperties(target, /*#__PURE__*/_Object$getOwnPropertyDescriptors(source)) : _forEachInstanceProperty(_context3 = /*#__PURE__*/ownKeys( /*#__PURE__*/Object(source))).call(_context3, function (key) { _Object$defineProperty(target, key, /*#__PURE__*/_Object$getOwnPropertyDescriptor(source, key)); }); } return target; }

// 根据 store state key 的前缀 $ 决定是否要缓存 (双 $$ 表示要多 tab 同步)。
// 另外如果 store state 的值是 object 且有 expireAt(RFC3339) 字段，将判断是否过期。过期则不读。

var persistp = function persistp() {
  var key = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
  return [/*#__PURE__*/_startsWithInstanceProperty(key).call(key, "$"), key[1] === "$"];
};
var persister = name => {
  var memory = /*#__PURE__*/localMemory({
    name: name || "app"
  });
  var connect = store$ => {
    var prevState = {};
    var sub = /*#__PURE__*/merge( /*#__PURE__*/store$.pipe( /*#__PURE__*/tap(function () {
      var nextState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var allPersists = /*#__PURE__*/uniq( /*#__PURE__*/filter([...keys(prevState), ...keys(nextState)], key => persistp(key)[0]));
      if (some(allPersists, it => _includesInstanceProperty(it).call(it, "access"))) {
        memory.clear();
        return;
      }
      var {
        toR,
        toS
      } = /*#__PURE__*/reduce(allPersists, (prev, cur) => {
        if (!!prevState[cur] && typeof nextState[cur] === "undefined") {
          prev.toR.push(cur);
        } else {
          prev.toS.$persist.push(cur);
          if (nextState[cur] !== prevState[cur]) {
            prev.toS[cur] = nextState[cur];
          }
        }
        return prev;
      }, {
        toR: [],
        toS: {
          $persist: []
        }
      });
      prevState = nextState;
      void memory.writeByRecord(toS);
      memory.remove(...toR);
    })), /*#__PURE__*/fromEvent(_globalThis, "storage").pipe( /*#__PURE__*/tap(e => {
      var _context;
      if (!e.isTrusted || !e.key || !e.newValue) {
        return;
      }
      var prefix = memory.keyPrefix;
      if (!_startsWithInstanceProperty(_context = e.key).call(_context, prefix)) {
        return;
      }
      var finalKey = /*#__PURE__*/e.key.replace(prefix, "");
      if (finalKey[1] !== "$") {
        return;
      }
      try {
        var value = /*#__PURE__*/JSON.parse(e.newValue);
        store$.next( /*#__PURE__*/_objectSpread( /*#__PURE__*/_objectSpread({}, store$.value), {}, {
          [finalKey]: value
        }));
        console.warn(finalKey, "updated from storage");
      } catch (e) {
        // -
      }
    }))).subscribe();
    return () => {
      prevState = {};
      sub.unsubscribe();
    };
  };
  var hydrate = () => {
    var persistKeys = /*#__PURE__*/memory.read("$persist");
    var parsed = /*#__PURE__*/reduce(persistKeys, (prev, cur) => {
      var value = /*#__PURE__*/memory.readByExpired(cur);
      if (typeof value !== "undefined" && value !== null) {
        prev[cur] = value;
      }
      return prev;
    }, {});
    if (process.env.NODE_ENV !== "production") {
      // eslint-disable-next-line
      console.log("hydrated", parsed);
    }
    return parsed;
  };
  return {
    connect,
    hydrate
  };
};

var PersisterConnect = _ref => {
  var {
    persister
  } = _ref;
  var store$ = /*#__PURE__*/useStore();
  useEffect(() => {
    var cleanup = /*#__PURE__*/persister.connect(store$);
    return () => cleanup();
  }, []);
  return null;
};

export { PersisterConnect, persister };
