interface LocalMemoryOptions {
    name?: string;
    size?: number;
    description?: string;
}
interface LocalMemory {
    clear(): void;
    writeByRecord(arg: Record<string, any>): Promise<Array<string | void> | void>;
    read<T = any>(key: string): T | undefined;
    readByExpired<T = any>(key: string, expireField?: string): T | undefined;
    write<T>(key: string, value: T): Promise<string | void>;
    remove(...key: string[]): void;
    iterate(iterator: (value: any | undefined, key: string, index: number) => void): void;
    has(key: string): boolean;
    keyPrefix: string;
    name: string;
}
interface CreateBlobOptions {
    type?: string;
}

declare const localMemory: ({ name }: LocalMemoryOptions) => LocalMemory;

export { CreateBlobOptions, LocalMemory, LocalMemoryOptions, localMemory };
